// Main module
module finalproject(armedIn, beam, clk, disarmedIn, armedState, beamOut, disarmedState, speaker, SSD, SSD1, SSD2, triggeredState) ;
	input armedIn; // SW0
	input beam; 
	input clk;
	input disarmedIn; // SW1
	output reg armedState = 0; //LEDR17
	output beamOut; //LEDG0
	output reg disarmedState = 1; //LEDR16
	output speaker;
	output [6:0]SSD, SSD1, SSD2; 
	output reg triggeredState = 0; 
	parameter on = 1;
	parameter off = 0;
		
	assign beamOut = beam;									// indicated on ledg0 if the beam is broken
	
	// watching all of the inputs
	always @(armedIn, disarmedIn, beam)
	begin
		if (armedIn) 
			begin
			armedState <= on;
			disarmedState <= off;
			end
		if (disarmedIn) 
			begin
			armedState <= off;
			disarmedState <= on;
			triggeredState <= off;
			end
		if ((beam == 0) && (armedState == 1) && (disarmedState == 0))
			triggeredState <= on;
	end
	
	armedStatusDisplay display1(armedState,SSD,SSD1,SSD2); 		// displays the current state of the alarm on SSD
	alarmSound alarm1(speaker, clk, triggeredState);		// sound the alarm
endmodule 

// code in alarm module is taken from http://www.fpga4fun.com/MusicBox1.html and modified
module alarmSound(speaker, clk, triggeredState); 
	input clk;
	input triggeredState;
	output speaker;
	parameter clkdivider = 25000000/440/2;

	reg [23:0] tone;
	always @(posedge clk) 
		if (triggeredState == 1)
			tone <= tone+1;

	reg [14:0] counter;
	always @(posedge clk) 
		if (triggeredState == 1) 
		begin
			if(counter==0) 
				counter <= (tone[23] ? clkdivider-1 : clkdivider/2-1); 
			else 
				counter <= counter-1; 
		end

	reg speaker;
		always @(posedge clk) 
			if (triggeredState == 1)
				if(counter==0) 
					speaker <= ~speaker;

	
	/* Working Code for single tone
	always @(posedge clk) 
				if (triggeredState == 1) 
					counter <= counter+1;
	assign speaker = counter[15];
	*/			
endmodule

module armedStatusDisplay(armedState, SSD, SSD1, SSD2); 
	input armedState;
	output reg [6:0]SSD, SSD1, SSD2;
	
	always @(armedState)
		begin
		SSD2 = 7'b0000001;
			if(armedState == 1)
				begin SSD = 7'b1111111; SSD1 = 7'b0001001; end
			else 
				begin SSD = 7'b0111000;	SSD1 = 7'b0111000; end
		end
endmodule







		